items/urls.py
from django.urls import path, include
from items.views import HomeView, ItemDetailView, ItemUpdateView, ItemCreateView, SearchItemView, SearchCategoryView, SearchPriceView, ItemActionView, RentListView, SearchLocationView

urlpatterns = [
    path('', HomeView.as_view(), name='home'),
    path('item/create/', ItemCreateView.as_view(), name='item-create'),
    path('item/search/', SearchItemView.as_view(), name='search'),
    path('item/category/search', SearchCategoryView.as_view(), name='search_category'),
    path('item/price/search', SearchPriceView.as_view(), name='search_price'),
    path('item/location/search', SearchLocationView.as_view(), name='search_location'),
    path("item/<int:pk>/actions/accept/<int:rental_pk>/", ItemActionView.as_view(action="accept"), name="item_accept"),
    path("item/<int:pk>/actions/reject/<int:rental_pk>/", ItemActionView.as_view(action="reject"), name="item_reject"),
    path("item/<int:pk>/actions/cancel/<int:rental_pk>/", ItemActionView.as_view(action="cancel"), name="cancel_request"),
    path("item/<int:pk>/actions/switchrent/", ItemActionView.as_view(action="switchrent"), name="switchrent"),
    path("item/<int:pk>/actions/rent/", ItemActionView.as_view(action="rent"), name="item_rent"),
    path("item/<int:pk>/remove/", ItemActionView.as_view(action="remove", validate=True), name="item_remove"),
    path("item/rentrequests/", RentListView.as_view(), name='rent_requests'),
    path('item/update/<slug:itemslug>', ItemUpdateView.as_view(), name='item-update'),
    path('item/<slug:itemslug>/', ItemDetailView.as_view(), name='item-detail'),
]

main/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
urlpatterns = [
    path('admin/', admin.site.urls),
    path('user/', include('users.urls')),
    path('communication/', include('communication.urls')),
    path('', include('items.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

users/urls.py
from django.urls import path, include
from .views import RegistrationView,Login,PasswordResetView,ProfileDetailView,ProfileUpdateView,PasswordChangeView
from django.urls import reverse_lazy
from django.contrib.auth.views import LogoutView
app_name = 'users'
urlpatterns = [
    path('register/', RegistrationView.as_view(), name='register' ),
    path('login/', Login.as_view(), name='login' ),
    path('logout/', LogoutView.as_view(next_page = "/user/logged_out/"), name='logout'),
    path('logged_out/', LogoutView.as_view(next_page=None,template_name="user/logged_out.html"), name='logged_out'),
    path('reset_password/', PasswordResetView.as_view(), name='reset_password' ),
    path('profile/<int:pk>/', ProfileDetailView.as_view(), name='user_profile' ),
    path('profile/me/', ProfileDetailView.as_view(is_me=True), name='me' ),
    path('profile/edit/', ProfileUpdateView.as_view(), name='profile_update' ),
    path('change_password/', PasswordChangeView.as_view(success_url="/user/password_changed/"), name='password_change' ),
    path('password_changed/', PasswordChangeView.as_view(template_name="user/password_changed.html"), name='password_changed' ),
]

items/models.py
from django.db import models
from django.conf import settings
from django.utils.text import slugify


class Category(models.Model):
    COLORS = (
        ('S', 'success'),
        ('P', 'primary'),
        ('I', 'info'),
        ('W', 'warning'),
        ('D', 'danger'),
        ('A', 'dark'),
        ('E', 'secondary'),
        ('L', 'light')
    )

    ICONS = (
        ('T', 'mobile-alt'),
        ('B', 'book'),
        ('M', 'music'),
        ('C', 'car'),
        ('H', 'home'),
        ('A', 'basketball-ball'),
        ('E', 'headphones'),
        ('D', 'baby-carriage'),
    )
    name = models.CharField(max_length=50)
    color = models.CharField(max_length=1, choices=COLORS, default='P')
    icon = models.CharField(max_length=1, choices=ICONS, default='B')

    slug = models.SlugField(unique=True, null=True, blank=True)

    def save(self, *args, **kwargs):
        self.slug = slugify(self.name)
        super(Category, self).save(*args, **kwargs)

    def __str__(self):
        return self.name    


class Item(models.Model):
    owner = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True, related_name='items')
    name = models.CharField(max_length=50)
    description = models.TextField(max_length=250)
    price = models.FloatField()
    picture = models.ImageField(upload_to='item_pictures/', default="item_pictures/default.jpg")
    is_available = models.BooleanField(default=True)
    created_at = models.DateField(auto_now_add=True)
    updated_at = models.DateField(auto_now=True)
    category = models.ForeignKey(Category, on_delete=models.DO_NOTHING, related_name='items')

    slug = models.SlugField(unique=True, null=True, blank=True)

    def save(self, *args, **kwargs):
        self.slug = slugify(self.name)
        return super(Item, self).save(*args, **kwargs)
    def __str__(self):
        return self.name
    

class ItemRental(models.Model):
    item = models.ForeignKey(Item, on_delete=models.SET_NULL, null=True)
    hirer = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True)
    fulfilled = models.BooleanField(default=False)
    created = models.DateTimeField(auto_now_add=True)

items/forms.py
from django import forms

from items.models import Category, Item 



class ItemCreateForm(forms.ModelForm):
    class Meta:
        model = Item
        fields = ['name', 'description', 'price', 'picture', 'is_available', 'category']
        

items/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import render, get_object_or_404
from django.utils import timezone
from django.views.generic.list import ListView
from django.views.generic import DetailView, UpdateView, CreateView, RedirectView
from items.models import Item, Category, ItemRental
from items.forms import ItemCreateForm
from django.urls import reverse
from django.db.models import Q, Prefetch
from django.utils.translation import gettext_noop
from django.http import HttpResponseRedirect
from django.contrib import messages

class HomeView(ListView):
    model = Item
    template_name = 'home.html'
    context_object_name = 'items'

    def get_queryset(self):
        queryset = {'all_items': Item.objects.order_by('created_at').filter(is_available=True).all(), 
                    'all_categories': Category.objects.all(),
                    }
        return queryset



class ItemCreateView(CreateView):
    model = Item
    form_class = ItemCreateForm
    template_name = "item/item_create.html"
    success_url = '/'

    def form_valid(self, form):
        form.instance.owner = self.request.user
        return super(ItemCreateView, self).form_valid(form)


class ItemUpdateView(LoginRequiredMixin, UpdateView):
    model = Item
    fields = ['name', 'description', 'price', 'picture', 'is_available', 'category']
    template_name = 'item/item_update.html'
    slug_url_kwarg='itemslug'
    success_url = '/'

    def get_object(self):
        item = Item.objects.filter(slug=self.kwargs['itemslug']).first()
        return item

    def get_queryset(self):
        qs = super(ItemUpdateView, self).get_queryset()
        return qs.filter(user=self.request.user)    


class SearchItemView(ListView):
    model = Item
    template_name = "home.html"
    context_object_name = 'items'

    def get_queryset(self):
        query = self.request.GET.get('q')
        
        queryset = {'all_items': Item.objects.filter(Q(name__icontains=query)).order_by('created_at').filter(is_available=True).all(), 
                    'all_categories': Category.objects.all(),
                    'is_search': True}
        return queryset    
   
class SearchCategoryView(ListView):
    model = Item
    template_name = 'home.html'
    context_object_name = 'items'
    def get_queryset(self):
        query = self.request.GET.get('q')
        cat = Category.objects.filter(name=query).first()
        catid = cat.id
        queryset = {'all_items': Item.objects.filter(Q(category=catid)).order_by('created_at').filter(is_available=True).all(), 
                    'all_categories': Category.objects.all(),
                    'is_search': True}
        return queryset    

class SearchPriceView(ListView):
    model = Item
    template_name = 'home.html'
    context_object_name = 'items'

    def get_queryset(self):
        minQuery = self.request.GET.get('minPrice')
        maxQuery = self.request.GET.get('maxPrice')
        queryset = {'all_items': Item.objects.filter(price__range=(minQuery, maxQuery)).order_by('created_at').filter(is_available=True).all(), 
                    'all_categories': Category.objects.all(),
                    'minimum': minQuery,
                    'maximum': maxQuery,
                    'is_search': True
                    }
        return queryset   

class SearchLocationView(ListView):
    model = Item
    template_name = 'home.html'
    context_object_name = 'items'

    def get_queryset(self):
        locationQuery = self.request.GET.get('location')
        queryset = {'all_items': Item.objects.filter(owner__location__icontains=locationQuery).order_by('created_at').filter(is_available=True).all(), 
                    'all_categories': Category.objects.all(),
                    'is_search': True
                    }
        return queryset   


class ItemDetailView(DetailView):
    model = Item
    template_name = 'item/item_detail.html'
    context_object_name='item'
    slug_url_kwarg='itemslug'

    # def get_queryset(self):
    #     queryset = super(ItemDetailView, self).get_queryset()
    #     queryset=queryset.filter(
    #         Q(slug=self.kwargs['categoryslug'])|
    #         Q(slug=self.kwargs['itemslug'])
    #     )
    #     return queryset
    # def get_object(self, queryset=None):
    #     if self.is_me:
    #         return self.request.user
    #     else:
    #         return super().get_object(queryset)


    # def get_context_data(self, *args, **kwargs):
    #     context = super().get_context_data(**kwargs)
    #     context['category'] = Category.objects.filter(Q(slug=self.kwargs['categoryslug']))
    #     context['itemdetail'] = Item.objects.filter(Q(slug=self.kwargs['itemslug']))
    #     context["is_me"] = self.is_me
    #     return context

    # def get_object(self):
    #     obj=self.model.objects.get(
    #     Q(
    #     slug__icontains=self.kwargs['categoryslug']| 
    #     Q(
    #         slug__icontains=self.kwargs['itemslug'])
    #     ))

    #     return obj

class ItemActionView(RedirectView):
    action = None
    validate = False
    url = None
    context_object_name='item'

    def get_redirect_url(self, *args, **kwargs):
        return self.url or reverse("users:me")

    def apply_action(self, action):
        if action == gettext_noop("rent"):
            renting = ItemRental.objects.filter(Q(hirer__exact=self.request.user) & Q(item__exact=self.item))
            if renting:
                messages.add_message(self.request, messages.WARNING, 'Zaten Kiralama İsteği Var')
            else:
                ItemRental.objects.create(hirer=self.request.user, item=self.item)
                messages.add_message(self.request, messages.SUCCESS, 'Kiralama İsteği Yapıldı')
            self.url= reverse("item-detail", kwargs={'itemslug':self.item.slug }) 
        elif action == gettext_noop("edit"):
            self.url = reverse("item-update", kwargs={"pk": self.item.id})
        elif action == gettext_noop("accept"):
            rental = ItemRental.objects.get(id=self.kwargs["rental_pk"])
            rental.fulfilled = True
            rental.save(update_fields=["fulfilled"])
            rental.item.is_available = False
            rental.item.save(update_fields=["is_available"])
            ItemRental.objects.exclude(id=rental.id).all().delete()
            self.url = reverse("rent_requests")
        elif action == gettext_noop("reject"):
            rental = ItemRental.objects.get(id=self.kwargs["rental_pk"])
            rental.delete()
            self.url = reverse("rent_requests")
        elif action == gettext_noop("cancel"):
            rental = ItemRental.objects.get(id=self.kwargs["rental_pk"])
            rental.delete()
        elif action == gettext_noop("switchrent"):
            self.item.is_available = not self.item.is_available
            self.item.save(update_fields=["is_available"])
        elif action == gettext_noop("remove"):
            self.item.delete()
        else:
            pass
    


    def get(self, request, *args, **kwargs):
        self.item = Item.objects.get(id=self.kwargs["pk"])
        if self.validate and not request.GET.get("valid") == 'true':
            return render(request, "item/validate.html", {"item": self.item, "action": self.action})
        else:
            self.apply_action(self.action)
            return super().get(request, *args, **kwargs)


class RentListView(LoginRequiredMixin, ListView):
    model = ItemRental
    template_name = 'item/rent_requests.html'
    context_object_name = 'items'
    
    def get_queryset(self):
        queryset = super(RentListView, self).get_queryset()
        queryset = {'all_rents':ItemRental.objects.all().prefetch_related(Prefetch('item', queryset=Item.objects.select_related('owner')))}
        return queryset

templates/item/detail.html
{% for i in itemdetail %}
    {% for c in category %}
    <div class="row">
        <div class="col-6">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="#">Anasayfa</a></li>
                    <li class="breadcrumb-item"><a href="#">{{c.name}}</a></li>
                    <li class="breadcrumb-item active" aria-current="page">{{i.name}}</li>
                </ol>
            </nav>
            <img id="itemdetail-image" src="{{i.picture.url}}" width="500px" height="500px" alt="ItemPicture">
        </div>
        <div class="col-6" id="itemdetail-description">
            {% if request.user.id == i.owner.id %}
                <a class="btn btn-outline-primary" href="{% url 'item-update' i.slug %}">Güncelle</a>
                <a class="btn btn-outline-danger" href="{% url 'item-update' i.slug %}">Sil</a>
            {% else %}
                {% if i.is_available %}
                <a class="btn btn-outline-success" href="#">Kirala</a>
                {% else %}
                <a class="btn btn-danger" href="#">Urun Kiralık Değil</a>
                {% endif %}
            {% endif %}
            <br>
            <br>
            <h3>₺{{i.price}}</h3>
            <br>
            <h4>{{i.name}}</h4>
            <br>
            <p class="font-italic">{{i.created_at}} tarihinde kiraya verildi</p>
            <hr>
            <p style="color:gray" >{{i.description}}</p>
            <div class="badge badge-danger text-wrap" id="itemdetail-owner" style="width: 6rem;">
                {{i.owner}}
            </div>
            <br>
            <p style="color:gray">Satıcıya mesaj at</p>
            <br>
            <div class="card">
                <div class="card-body">
                    
                        <p>Rented by rental.hirer</p>
                    
                        <p>Requested by rental.hirer
                        
                            <a class="btn btn-sm btn-primary"
                               href="#">Accept</a>
                        
                        </p>
                    
                    <p>Date rental.created</p>
                </div>
            </div>

        </div>
    </div>
    {% endfor %}
    {% endfor %}
</div>

{% else %}
    <h1>Ürün Bulunamadı</h1>
{% endif %}

{% if category and itemdetail%}
    
    {% for i in category  %}
        {{i}}
    {% endfor %}
    
    {% for i in itemdetail  %}
        {{i}}
    {% endfor %}
        
        
{% else %}
    <h1>nothing!</h1>
    dneme
{% endif %}
    
    
{% endblock body %}

templates/item/item_create.html
{% extends "base.html" %}

{% block title %}Kira Urun Ekle{% endblock %}
{% load crispy_forms_tags %}

{% block body %}
    <form method="POST" class="form-group" style="margin-top: 5%;" enctype="multipart/form-data">
	{% csrf_token %}
	<div class="row justify-content-center">
		<div class="col-6">
		{{ form|crispy }}
		<div class="col text-center">
			<button type="submit" class="btn btn-success">İlan Ver</button>
		</div>
		</div>
	</div>
    </form>
{% endblock %}

templates/item/item_detail.html
{% extends 'base.html' %}

{% block body %}
<div class="container" id="itemdetail">
        {% if messages %}
        <ul class="messages">
            {% for message in messages %}
            <div class="alert alert-{{message.tags}}" role="alert">
                {{message}}
            </div>       
            {% endfor %}
        </ul>
        {% endif %}
    <div class="row">
        <div class="col-6">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="{% url 'home' %}">Anasayfa</a></li>
                    <li class="breadcrumb-item">
                        <a href="#">{{item.category}}</a>
                    </li>
                    <li class="breadcrumb-item active" aria-current="page">{{item.name}}</li>
                </ol>
            </nav>
            <img id="itemdetail-image" src="{{item.picture.url}}" width="500px" height="500px" alt="ItemPicture">
        </div>
        <div class="col-6" id="itemdetail-description">
            {% if request.user.id %}
            {% if item.owner == request.user %}
            <a class="btn btn-outline-primary" href="{% url 'item-update' item.slug %}">Güncelle</a>
            <a class="btn btn-outline-danger" href="{% url 'item_remove' pk=item.id %}">Sil</a>
            {% else %}
            {% if item.is_available %}
            <a class="btn btn-outline-success" href="{% url "item_rent" pk=item.id %}">Kiralama İsteği Yap</a>
            {% else %}
            <a class="btn btn-danger" href="#">Urun Kiralık Değil</a>
            {% endif %}
            {% endif %}
            {% endif %}

            <br>
            <br>
            <h3>₺{{item.price}}</h3>
            <br>
            <h4>{{item.name}}</h4>
            <br>
            <p class="font-italic">{{item.created_at}} tarihinde ilan verildi</p>
            <hr>
            <p style="color:gray">{{item.description}}</p>
            <a href="{% url 'users:user_profile' pk=item.owner.id %}" class="badge badge-danger text-wrap" id="itemdetail-owner" style="width: 6rem;">
                {{item.owner}}
            </a>
            <br>
            <!-- <p style="color:gray">Satıcıya mesaj at</p> -->
            <a style="color:gray" {%if request.user.id and request.user != item.owner %}
                href="/communication/detail/{{item.owner.id}}/send">Mesaj göndermek için tıklayınız.
                {% elif not request.user.id %}
                >Mesaf göndermek için giriş yapınız.
                {% endif %}
            </a>
            <br>
            {% if item.is_available == False %}
            <a href="#" class="btn btn-warning">Urun Kiralanmış Durumda</a>
            {% endif %}
            {% if item.itemrental_set.all %}
            <a href="#" class="btn btn-warning">Kiralama İstekleri Var</a>
            {% endif %}

        </div>
    </div>
</div>



{% endblock body %}

templates/item/item_search.html
{% extends 'base.html' %}

{% block body %}
<div class="jumbotron jumbotron-fluid">
        <div class="container">
          <h1 class="display-4" style="color:white;">Renten</h1>
          <a href="" class="btn btn-info">Kayıt Ol</a><a href="" class="btn btn-success">Giriş Yap</a>
        </div>
  </div>
  <div class="container">
    <div class="row text-center">
      {%for category in items.all_categories%}
        <div class="col-1">
            <a class="btn btn-{{category.get_color_display}} btn-circle btn-circle-lg m-1">
              <i class="fa fa-{{category.get_icon_display}}"></i>
              <span>{{category.name}}</span>
            </a>
        </div>
      {% endfor %}  
    </div>
    <div class="dropdown" style="margin-top:5%;">
        <button class="btn btn-light dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          Fiyat
        </button>
        <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
          <form method="GET" action="">
            {% csrf_token %}
            <input type="number" placeholder="Min" step="0.01" min="0" id="minPrice" name="minPrice">
            - <input type="number" placeholder="Max" step="0.01" min="0" id="maxPrice" name="maxPrice">
            <input type="submit" value="submit" style="display: none;"/>
          </form>  
        </div>
      </div>
      
    <div class="row text-center" id="items-mainpage">
      {% for item in items.all_items %}
        <div class="col-3">
          <div class="card">
            <img class="card-img-top" id="item-image" src="{{ item.picture.url }}" alt="Card image cap">
            <div class="card-body">
              <h5 class="card-title" id="item-header"><a href="{% url 'item-detail' item.category.slug item.slug %}">{{item.name}}</a></h5>
              <p class="card-text" id="item-text">{{item.description|truncatewords:5}}...</p>
              <p class="card-text"></p>
            </div>
          </div>
        </div>
      {% endfor %}
    </div>
  </div>
  
{% endblock body %}

templates/item/item_update.html
{% extends "base.html" %}

{% block title %}Ürün Güncelle{% endblock %}
{% load crispy_forms_tags %}

{% block body %}
    <form method="POST" class="form-group" style="margin-top: 5%;" enctype="multipart/form-data">
	{% csrf_token %}
	<div class="row justify-content-center">
		<div class="col-6">
		{{ form|crispy }}
		<div class="col text-center">
			<button type="submit" class="btn btn-success">Güncelle</button>
		</div>
		</div>
	</div>
    </form>
{% endblock %}

templates/item/rent_requests.html
{% extends 'base.html' %}

{% block body %}

    <h1 style="text-align: center; margin-top:5%;">Kiralama İstekleri</h1>
    <table class="table">
            <thead>
              <tr>
                <th scope="col">Urun</th>
                <th scope="col">İsteği Yapan</th>
                <th scope="col">Tarih</th>
                <th scope="col">Karar</th>
              </tr>
            </thead>
            <tbody>
            {% for i in items.all_rents %}
                {% if i.item.owner == request.user and i.fulfilled == False %}
                    <tr>
                        <td>{{i.item.name}}</td>
                        <td>{{i.hirer}}</td>
                        <td>{{i.created}}</td>
                        <td>
                            <a class="btn btn-success" href="{% url 'item_accept' pk=i.item.owner.id rental_pk=i.id %}">Kabul</a>
                            <a class="btn btn-danger" href="{% url 'item_reject' pk=i.item.owner.id rental_pk=i.id %}">Red</a>
                        </td>
                    </tr>
                {% endif %}
            {% endfor %}  
            </tbody>
          </table>
          
    

{% endblock body %}

templates/item/validate.html
{% extends "base.html" %}

{% block body %}
    <div class="row">
        <div class="col-4 offset-4" style="margin-top: 10%;">
            <span class="text-info">{{ item }}</span> ürünü sistemden silinecek <strong class="text-warning">Emin misiniz?</strong>
            <form method="GET">
                <button type="submit" class="btn btn-primary"  name="valid" value="true">Evet</button>
                <a class="btn btn-primary" href="{% url 'item-detail' item.slug %}">Hayır</a>
            </form>
        </div>
    </div>
{% endblock %}